| OGRE 1.11.1 Object-Oriented Graphics Rendering Engine

Public Member Functions | Public Attributes | List of all members
Ogre::PixelBox Class Reference
Core » Image

A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory. More...

`#include <OgrePixelFormat.h>`

Inheritance diagram for Ogre::PixelBox:
[legend]

## Public Member Functions
| PixelBox ()
| Parameter constructor for setting the members manually. More...
| PixelBox (const Box &extents, PixelFormat pixelFormat, void *pixelData=0)
| Constructor providing extents in the form of a Box object. More...
| PixelBox (uint32 width, uint32 height, uint32 depth, PixelFormat pixelFormat, void *pixelData=0)
| Constructor providing width, height and depth. More...
| ~PixelBox ()
bool | contains (const Box &def) const
| Return true if the other box is a part of this one. More...
ColourValue | getColourAt (size_t x, size_t y, size_t z) const
| Get colour value from a certain location in the PixelBox. More...
size_t | getConsecutiveSize () const
| Return the size (in bytes) this image would take if it was laid out consecutive in memory. More...
uint32 | getDepth () const
| Get the depth of this box. More...
uint32 | getHeight () const
| Get the height of this box. More...
size_t | getRowSkip () const
| Get the number of elements between one past the rightmost pixel of one row and the leftmost pixel of the next row. More...
size_t | getSliceSkip () const
| Get the number of elements between one past the right bottom pixel of one slice and the left top pixel of the next slice. More...
PixelBox | getSubVolume (const Box &def, bool resetOrigin=true) const
| Return a subvolume of this PixelBox. More...
uchar * | getTopLeftFrontPixelPtr () const
| Return a data pointer pointing to top left front pixel of the pixel box. More...
uint32 | getWidth () const
| Get the width of this box. More...
bool | isConsecutive () const
| Return whether this buffer is laid out consecutive in memory (ie the pitches are equal to the dimensions) More...
void | setColourAt (ColourValue const &cv, size_t x, size_t y, size_t z)
| Set colour value at a certain location in the PixelBox. More...
void | setConsecutive ()
| Set the rowPitch and slicePitch so that the buffer is laid out consecutive in memory. More...

## Public Attributes
uint32 | back
uint32 | bottom
uchar * | data
| The data pointer. More...
PixelFormat | format
| The pixel format. More...
uint32 | front
uint32 | left
uint32 | right
size_t | rowPitch
| Number of elements between the leftmost pixel of one row and the left pixel of the next. More...
size_t | slicePitch
| Number of elements between the top left pixel of one (depth) slice and the top left pixel of the next. More...
uint32 | top

## Detailed Description

A primitive describing a volume (3D), image (2D) or line (1D) of pixels in memory.

In case of a rectangle, depth must be 1. Pixels are stored as a succession of "depth" slices, each containing "height" rows of "width" pixels.

Note that the left, top, and front edges are included but the right, bottom and back ones are not.

## Constructor & Destructor Documentation

## ◆ PixelBox() [1/3]

Ogre::PixelBox::PixelBox | ( |  | ) |
| inline

Parameter constructor for setting the members manually.

## ◆ ~PixelBox()

Ogre::PixelBox::~PixelBox | ( |  | ) |
| inline

## ◆ PixelBox() [2/3]

Ogre::PixelBox::PixelBox | ( | const Box & | extents,
|  | PixelFormat | pixelFormat,
|  | void * | pixelData = `0`
| ) |  |
| inline

Constructor providing extents in the form of a Box object.

This constructor assumes the pixel data is laid out consecutively in memory. (this means row after row, slice after slice, with no space in between)

Parameters

  extents | Extents of the region defined by data
  pixelFormat | Format of this buffer
  pixelData | Pointer to the actual data

## ◆ PixelBox() [3/3]

Ogre::PixelBox::PixelBox | ( | uint32 | width,
|  | uint32 | height,
|  | uint32 | depth,
|  | PixelFormat | pixelFormat,
|  | void * | pixelData = `0`
| ) |  |
| inline

Constructor providing width, height and depth.

This constructor assumes the pixel data is laid out consecutively in memory. (this means row after row, slice after slice, with no space in between)

Parameters

  width | Width of the region
  height | Height of the region
  depth | Depth of the region
  pixelFormat | Format of this buffer
  pixelData | Pointer to the actual data

## Member Function Documentation

## ◆ setConsecutive()

void Ogre::PixelBox::setConsecutive | ( |  | ) |
| inline

Set the rowPitch and slicePitch so that the buffer is laid out consecutive in memory.

## ◆ getRowSkip()

size_t Ogre::PixelBox::getRowSkip | ( |  | ) | const
| inline

Get the number of elements between one past the rightmost pixel of one row and the leftmost pixel of the next row.

(IE this is zero if rows are consecutive).

## ◆ getSliceSkip()

size_t Ogre::PixelBox::getSliceSkip | ( |  | ) | const
| inline

Get the number of elements between one past the right bottom pixel of one slice and the left top pixel of the next slice.

(IE this is zero if slices are consecutive).

## ◆ isConsecutive()

bool Ogre::PixelBox::isConsecutive | ( |  | ) | const
| inline

Return whether this buffer is laid out consecutive in memory (ie the pitches are equal to the dimensions)

## ◆ getConsecutiveSize()

size_t Ogre::PixelBox::getConsecutiveSize | ( |  | ) | const

Return the size (in bytes) this image would take if it was laid out consecutive in memory.

## ◆ getSubVolume()

PixelBox Ogre::PixelBox::getSubVolume | ( | const Box & | def,
|  | bool | resetOrigin = `true`
| ) |  | const

Return a subvolume of this PixelBox.

Parameters

  def | Defines the bounds of the subregion to return
  resetOrigin | Whether to reset left/top/front of returned PixelBox to zero together with adjusting data pointer to compensate this, or do nothing so that returned PixelBox will have left/top/front of requested Box

Returns
  A pixel box describing the region and the data in it

Remarks
  This function does not copy any data, it just returns a PixelBox object with a data pointer pointing somewhere inside the data of object.

Exceptions

  Exception(ERR_INVALIDPARAMS) | if def is not fully contained

## ◆ getTopLeftFrontPixelPtr()

uchar* Ogre::PixelBox::getTopLeftFrontPixelPtr | ( |  | ) | const

Return a data pointer pointing to top left front pixel of the pixel box.

Remarks
  Non consecutive pixel boxes are supported.

## ◆ getColourAt()

ColourValue Ogre::PixelBox::getColourAt | ( | size_t | x,
|  | size_t | y,
|  | size_t | z
| ) |  | const

Get colour value from a certain location in the PixelBox.

The z coordinate is only valid for cubemaps and volume textures. This uses the first (largest) mipmap.

## ◆ setColourAt()

void Ogre::PixelBox::setColourAt | ( | ColourValue const & | cv,
|  | size_t | x,
|  | size_t | y,
|  | size_t | z
| ) |  |

Set colour value at a certain location in the PixelBox.

The z coordinate is only valid for cubemaps and volume textures. This uses the first (largest) mipmap.

## ◆ contains()

bool Ogre::Box::contains | ( | const Box & | def | ) | const
| inline inherited

Return true if the other box is a part of this one.

References Ogre::Box::back, Ogre::Box::bottom, Ogre::Box::front, Ogre::Box::left, Ogre::Box::right, and Ogre::Box::top.

## ◆ getWidth()

uint32 Ogre::Box::getWidth | ( |  | ) | const
| inline inherited

Get the width of this box.

References Ogre::Box::left, and Ogre::Box::right.

## ◆ getHeight()

uint32 Ogre::Box::getHeight | ( |  | ) | const
| inline inherited

Get the height of this box.

References Ogre::Box::bottom, and Ogre::Box::top.

## ◆ getDepth()

uint32 Ogre::Box::getDepth | ( |  | ) | const
| inline inherited

Get the depth of this box.

References Ogre::Box::back, and Ogre::Box::front.

## Member Data Documentation

## ◆ data

uchar* Ogre::PixelBox::data

The data pointer.

## ◆ format

PixelFormat Ogre::PixelBox::format

The pixel format.

## ◆ rowPitch

size_t Ogre::PixelBox::rowPitch

Number of elements between the leftmost pixel of one row and the left pixel of the next.

This value must always be equal to getWidth() (consecutive) for compressed formats.

## ◆ slicePitch

size_t Ogre::PixelBox::slicePitch

Number of elements between the top left pixel of one (depth) slice and the top left pixel of the next.

This can be a negative value. Must be a multiple of rowPitch. This value must always be equal to getWidth()*getHeight() (consecutive) for compressed formats.

## ◆ left

uint32 Ogre::Box::left
| inherited

Referenced by Ogre::Box::Box(), Ogre::Box::contains(), and Ogre::Box::getWidth().

## ◆ top

uint32 Ogre::Box::top
| inherited

Referenced by Ogre::Box::Box(), Ogre::Box::contains(), and Ogre::Box::getHeight().

## ◆ right

uint32 Ogre::Box::right
| inherited

Referenced by Ogre::Box::Box(), Ogre::Box::contains(), and Ogre::Box::getWidth().

## ◆ bottom

uint32 Ogre::Box::bottom
| inherited

Referenced by Ogre::Box::Box(), Ogre::Box::contains(), and Ogre::Box::getHeight().

## ◆ front

uint32 Ogre::Box::front
| inherited

Referenced by Ogre::Box::Box(), Ogre::Box::contains(), and Ogre::Box::getDepth().

## ◆ back

uint32 Ogre::Box::back
| inherited

Referenced by Ogre::Box::Box(), Ogre::Box::contains(), and Ogre::Box::getDepth().

The documentation for this class was generated from the following file:

- OgrePixelFormat.h